/*
       .
     GivelO  Dale Roberts,    
       
0x900
:    DDK BUILD
*/
#include <ntddk.h>
#include "GiveIOEx.h"
/*       */ 
#define DEVICE_NAME_STRING L"giveioex"
/*
 "" IOPM.      0x2000.  
8 * 8  = 64  IOPM,    64- 
 / 86 .     
    user-mode .    
   /   .
*/
#define IOPM_SIZE 0x2000
typedef UCHAR IOPM[IOPM_SIZE];
/*
     ,     
 IOPM  TSS  Ke386SetIoAccessMap().   
  .
*/
IOPM *IOPM_local = 0;
/*
   ,   ,   
  /  . Ke386IoSetAccessMap()  
  /  TSS. Ke386IoSetAccessProcess()   
 IOPM,       /  
.   IOPM     TSS, 
         /  
user-mode .
*/
void Ke386SetIoAccessMap(int, IOPM *);
void Ke386QueryIoAccessMap(int, IOPM *);
void Ke386IoSetAccessProcess(PEPROCESS, int);
NTSTATUS PsLookupProcessByProcessId(IN ULONG ulProcId, 
									OUT struct _EPROCESS ** pEProcess);
/*
  .
*/
NTSTATUS GiveioDeviceControl(IN PDEVICE_OBJECT DeviceObject,
							 IN PIRP Irp);
/*
     
*/
VOID GiveioUnload(IN PDRIVER_OBJECT DriverObject)
{
WCHAR DOSNameBuffer[] = L"\\DosDevlces\\" DEVICE_NAME_STRING;
UNICODE_STRING uniDOSString;
if(IOPM_local)
MmFreeNonCachedMemory(IOPM_local, sizeof(IOPM));
RtlInitUnicodeString(&uniDOSString, DOSNameBuffer);
IoDeleteSymbolicLink(&uniDOSString);
IoDeleteDevice(DriverObject->DeviceObject);
}
/*
 IOPM (  /)  ProcesslD ,  
    /.   OPM_local[] 
 , , IOPM .  OnFlag = 1, 
   /.     0,    .
*/
VOID SetIOPermissionMap(PEPROCESS ProcessID, int OnFlag)
{
Ke386IoSetAccessProcess(ProcessID, OnFlag);
Ke386SetIoAccessMap(1, IOPM_local);
}
/*
   .   .  
      .
*/
void GiveIO(void)
{
SetIOPermissionMap(PsGetCurrentProcess(), 1);
}
/*
   user-mode  CreateProcess().  
         DriverEntry().
 user-mode   CreateFile(),    
      ,   CPL (
  ),   0.   
,    kernel mode. GivelO()   
     /. ,  
 ,     /,  , - 
  ,  CreateFile().   
 .
*/
NTSTATUS GiveioCreateDispatch(
IN PDEVICE_OBJECT DeviceObject,
IN  PIRP  Irp
)
{
GiveIO(); //    
Irp->IoStatus.Information = 0;
Irp->IoStatus.Status = STATUS_SUCCESS;
IoCompleteRequest(Irp, IO_NO_INCREMENT);
return STATUS_SUCCESS;
}
/*
  .       
   .      
.         IPM  
,      . 
      .  
user-mode      , 
\\.\giveioex .
*/
NTSTATUS DriverEntry(
IN PDRIVER_OBJECT DriverObject,
IN PUNICODE_STRING RegistryPath
)
{
PDEVICE_OBJECT deviceObject;
NTSTATUS status;

WCHAR NameBuffer[] = L"\\Device\\" DEVICE_NAME_STRING;
WCHAR DOSNameBuffer[] = L"\\DosDevices\\"  DEVICE_NAME_STRING;
UNICODE_STRING uniNameString,   uniDOSString;

//     IOPM   .
IOPM_local = MmAllocateNonCachedMemory(sizeof(IOPM));
if(IOPM_local == 0)
 return  STATUS_INSUFFICIENT_RESOURCES;

RtlZeroMemory(IOPM_local, sizeof(IOPM));

//     
//    (device object)

RtlInitUnicodeString(&uniNameString, NameBuffer);
RtlInitUnicodeString(&uniDOSString, DOSNameBuffer);

status = IoCreateDevice(DriverObject, 0, &uniNameString,
			FILE_DEVICE_UNKNOWN, 0, FALSE, &deviceObject);
if(!NT_SUCCESS(status))
 return status;

status = IoCreateSymbolicLink (&uniDOSString, &uniNameString);
if (!NT_SUCCESS(status))
 return status;

//      
// . ,   ,    
// (Create)   (Unload)
DriverObject->MajorFunction[IRP_MJ_CREATE]= GiveioCreateDispatch;
DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] =
                                             GiveioDeviceControl;
DriverObject->DriverUnload = GiveioUnload;

return STATUS_SUCCESS;
}
NTSTATUS GiveioDeviceControl(IN PDEVICE_OBJECT DeviceObject,
							 IN PIRP pIrp
							 )

{
NTSTATUS               ntStatus = STATUS_SUCCESS;
PIO_STACK_LOCATION     irpSp;
ULONG                  inBufLength;   /*    */
ULONG                  outBufLength;  /*    */
PULONG                 LongBuffer;   /*     */

irpSp       = IoGetCurrentIrpStackLocation( pIrp );
inBufLength = irpSp->Parameters.DeviceIoControl.InputBufferLength;
LongBuffer = (PULONG) pIrp->AssociatedIrp.SystemBuffer;

switch ( irpSp->Parameters.DeviceIoControl.IoControlCode )
{
case IOCTL_IOPM_GET_ALL_ACCESS:
	{
		if (inBufLength >= 4) {
			ULONG ProcessID = LongBuffer[0];
	    	struct _EPROCESS *Process;
			
			PsLookupProcessByProcessId(ProcessID, &Process);
			Ke386SetIoAccessMap(1, IOPM_local);
			Ke386IoSetAccessProcess(Process, 1);
			ntStatus = STATUS_SUCCESS;
		} else  {
			ntStatus = STATUS_BUFFER_TOO_SMALL;
			pIrp->IoStatus.Information = 0;   /* Output Buffer Size  */
		}
		break;
	}
}

pIrp->IoStatus.Status = ntStatus;
IoCompleteRequest( pIrp, IO_NO_INCREMENT  );
return ntStatus;
}